package events

import "time"

type ConduitShardDisabledEvent struct {

	// The ID of the conduit.
	ConduitId string `json:"conduit_id"`

	// The ID of the disabled shard.
	ShardId string `json:"shard_id"`

	// The new status of the transport.
	Status string `json:"status"`

	// The disabled transport.
	Transport map[string]interface{} `json:"transport"`

	// Webhook callback URL. Null if method is set to websocket.
	Callback *string `json:"callback"`

	// WebSocket session ID. Null if  method is set to webhook.
	SessionId *string `json:"session_id"`

	// Time that the WebSocket session connected. Null if method is set to webhook.
	ConnectedAt *time.Time `json:"connected_at"`

	// Time that the WebSocket session disconnected. Null if method is set to webhook.
	DisconnectedAt *time.Time `json:"disconnected_at"`
}
