package events

import "time"

type StreamOnlineEvent struct {
	// The id of the stream.
	Id string `json:"id"`

	// The broadcaster’s user id.
	BroadcasterUserId string `json:"broadcaster_user_id"`

	// The broadcaster’s user login.
	BroadcasterUserLogin string `json:"broadcaster_user_login"`

	// The broadcaster’s user display name.
	BroadcasterUserName string `json:"broadcaster_user_name"`

	// The stream type. Valid values are: live, playlist, watch_party, premiere, rerun.
	Type string `json:"type"`

	// The timestamp at which the stream went online at.
	StartedAt time.Time `json:"started_at"`
}

type StreamOfflineEvent struct {
	// The broadcaster’s user id.
	BroadcasterUserId string `json:"broadcaster_user_id"`

	// The broadcaster’s user login.
	BroadcasterUserLogin string `json:"broadcaster_user_login"`

	// The broadcaster’s user display name.
	BroadcasterUserName string `json:"broadcaster_user_name"`
}
