package websocket

import "go.fifitido.net/twitch/eventsub/events"

type TransportOptions struct {
	// The address of the websocket server.
	//
	// If not specified it uses the default eventsub endpoint.
	Address *string

	// KeepaliveTimeoutSeconds sets the keep-alive timeout for the websocket
	// when connecting to the default eventsub endpoint
	//
	// Accepts values between 10 and 600
	KeepaliveTimeoutSeconds *int

	EventsHandler     events.Handler
	RevocationHandler events.RevocationHandler
}
